Index: anonymous.cs
===================================================================
--- anonymous.cs	(revision 63019)
+++ anonymous.cs	(working copy)
@@ -20,297 +20,721 @@
 
 namespace Mono.CSharp {
 
-	public abstract class AnonymousContainer : Expression
+	public abstract class CompilerGeneratedClass : Class
 	{
-		// Used to generate unique method names.
-		protected static int anonymous_method_count;
-		    
-		// An array list of AnonymousMethodParameter or null
-		public Parameters Parameters;
-		
-		//
-		// The block that makes up the body for the anonymous mehtod
-		//
-		public ToplevelBlock Block;
+		GenericMethod generic_method;
+		static int next_index = 0;
 
-		//
-		// The container block for this anonymous method.
-		//
-		public Block ContainingBlock;
+		private static MemberName MakeProxyName (GenericMethod generic, Location loc)
+		{
+			string name = String.Format ("<>c__CompilerGenerated{0}", ++next_index);
+			if (generic != null) {
+				TypeArguments args = new TypeArguments (loc);
+				foreach (TypeParameter tparam in generic.CurrentTypeParameters)
+					args.Add (new SimpleName (tparam.Name, loc));
+				return new MemberName (name, args, loc);
+			} else
+				return new MemberName (name, loc);
+		}
 
-		//
-		// The implicit method we create
-		//
-		public Method method;
+		protected string MakeName (string prefix)
+		{
+			return String.Format ("<>c__{0}{1}", prefix, ++next_index);
+		}
 
-		protected MethodInfo invoke_mb;
-		
-		// The emit context for the anonymous method
-		public EmitContext aec;
-		public string[] TypeParameters;
-		public Type[] TypeArguments;
-		protected bool unreachable;
+		protected CompilerGeneratedClass (TypeContainer parent, GenericMethod generic,
+						  int mod, Location loc)
+			: base (parent.NamespaceEntry, parent,
+				MakeProxyName (generic, loc), mod, null)
+		{
+			this.generic_method = generic;
 
-		// The method scope
-		ScopeInfo method_scope;
-		bool computed_method_scope = false;
-		
-		//
-		// The modifiers applied to the method, we aggregate them
-		//
-		protected int method_modifiers = Modifiers.PRIVATE;
-		
-		//
-		// Track the scopes that this method has used.  At the
-		// end this is used to determine the ScopeInfo that will
-		// host the method
-		//
-		ArrayList scopes_used = new ArrayList ();
-		
-		//
-		// Points to our container anonymous method if its present
-		//
-		public AnonymousContainer ContainerAnonymousMethod;	
+			if (generic != null) {
+				ArrayList list = new ArrayList ();
+				foreach (TypeParameter tparam in generic.TypeParameters) {
+					if (tparam.Constraints != null)
+						list.Add (tparam.Constraints.Clone ());
+				}
+				SetParameterInfo (list);
+			}
 
-		protected AnonymousContainer (Parameters parameters, ToplevelBlock container,
-					      ToplevelBlock block, Location l)
+			parent.AddCompilerGeneratedClass (this);
+		}
+
+		protected override bool DefineNestedTypes ()
 		{
-			Parameters = parameters;
-			Block = block;
-			loc = l;
+			RootContext.RegisterCompilerGeneratedType (TypeBuilder);
+			return base.DefineNestedTypes ();
+		}
 
-			//
-			// The order is important: this setups the CaptureContext tree hierarchy.
-			//
-			if (container == null) {
-				return;
+		protected override bool DoDefineMembers ()
+		{
+			if (!PopulateType ())
+				throw new InternalErrorException ();
+
+			members_defined = true;
+
+			if (!base.DoDefineMembers ())
+				return false;
+
+			if (CompilerGenerated != null) {
+				foreach (CompilerGeneratedClass c in CompilerGenerated) {
+					if (!c.DefineMembers ())
+						throw new InternalErrorException ();
+				}
 			}
-			container.SetHaveAnonymousMethods (l, this);
-			block.SetHaveAnonymousMethods (l, this);
+
+			return true;
 		}
 
-		protected AnonymousContainer (Parameters parameters, ToplevelBlock container,
-					      Location l):
-			this (parameters, container, new ToplevelBlock (container, parameters, l), l)
+		protected virtual bool PopulateType ()
 		{
+			if (type_populated)
+				return true;
+
+			type_populated = true;
+
+			if (!DoPopulateType ())
+				return false;
+
+			if (CompilerGenerated != null) {
+				foreach (CompilerGeneratedClass c in CompilerGenerated) {
+					if (!c.PopulateType ())
+						return false;
+				}
+			}
+
+			return true;
 		}
 
-		public override Expression DoResolve (EmitContext ec)
+		protected virtual bool DoPopulateType ()
 		{
-			//
-			// Set class type, set type
-			//
+			return true;
+		}
 
-			eclass = ExprClass.Value;
+		public GenericMethod GenericMethod {
+			get { return generic_method; }
+		}
 
-			//
-			// This hack means `The type is not accessible
-			// anywhere', we depend on special conversion
-			// rules.
-			// 
-			type = TypeManager.anonymous_method_type;
+		protected TypeExpr InflateType (Type it)
+		{
+			if (generic_method == null)
+				return new TypeExpression (it, Location);
 
-			return this;
+			if (it.IsGenericParameter && (it.DeclaringMethod != null)) {
+				int pos = it.GenericParameterPosition;
+				it = CurrentTypeParameters [pos].Type;
+			} else if (it.IsGenericType) {
+				Type[] args = it.GetGenericArguments ();
+
+				TypeArguments inflated = new TypeArguments (Location);
+				foreach (Type t in args)
+					inflated.Add (InflateType (t));
+
+				return new ConstructedType (it, inflated, Location);
+			} else if (it.IsArray) {
+				TypeExpr et_expr = InflateType (it.GetElementType ());
+				int rank = it.GetArrayRank ();
+
+				Type et = et_expr.ResolveAsTypeTerminal (this, false).Type;
+				it = et.MakeArrayType (rank);
+			}
+
+			return new TypeExpression (it, Location);
 		}
 
-		public void RegisterScope (ScopeInfo scope)
+		public Field CaptureVariable (string name, Type type)
 		{
-			if (scopes_used.Contains (scope))
-				return;
-			scopes_used.Add (scope);
+			if (members_defined)
+				throw new InternalErrorException ("Helper class already defined!");
+			if (type == null)
+				throw new ArgumentNullException ();
+
+			return new CapturedVariable (this, name, InflateType (type));
 		}
 
-		// Returns the deepest of two scopes
-		ScopeInfo Deepest (ScopeInfo a, ScopeInfo b)
+		bool type_populated;
+		bool members_defined;
+
+		internal void CheckMembersDefined ()
 		{
-			ScopeInfo p;
+			if (members_defined)
+				throw new InternalErrorException ("Helper class already defined!");
+		}
 
-			if (a == null)
-				return b;
-			if (b == null)
-				return a;
-			if (a == b)
-				return a;
+		public override void EmitType ()
+		{
+			Report.Debug (64, "COMPILER GENERATED EMIT TYPE", this, CompilerGenerated);
+			base.EmitType ();
+		}
 
-			//
-			// If they Scopes are on the same CaptureContext, we do the double
-			// checks just so if there is an invariant change in the future,
-			// we get the exception at the end
-			//
-			for (p = a; p != null; p = p.ParentScope)
-				if (p == b)
-					return a;
-			
-			for (p = b; p != null; p = p.ParentScope)
-				if (p == a)
-					return b;
+		protected class CapturedVariable : Field
+		{
+			public CapturedVariable (CompilerGeneratedClass helper, string name,
+						 TypeExpr type)
+				: base (helper, type, Modifiers.INTERNAL, name, null, helper.Location)
+			{
+				helper.AddField (this);
+			}
+		}
+	}
 
-			CaptureContext ca = a.CaptureContext;
-			CaptureContext cb = b.CaptureContext;
+	public abstract class ScopeInfoBase : CompilerGeneratedClass
+	{
+		public CaptureContext CaptureContext;
 
-			for (CaptureContext c = ca; c != null; c = c.ParentCaptureContext)
-				if (c == cb)
-					return a;
+		protected ScopeInfoBase (TypeContainer parent, GenericMethod generic,
+					 int mod, Location loc)
+			: base (parent, generic, mod, loc)
+		{ }
 
-			for (CaptureContext c = cb; c != null; c = c.ParentCaptureContext)
-				if (c == ca)
-					return b;
-			throw new Exception ("Should never be reached");
+		TypeExpr scope_type;
+		Field scope_instance;
+		ScopeInitializerBase scope_initializer;
+
+		public abstract AnonymousMethodHost Host {
+			get;
 		}
 
-		//
-		// Determines the proper host for a method considering the
-		// scopes it references
-		//
-		public void ComputeMethodHost ()
+		public Field ScopeInstance {
+			get { return scope_instance; }
+		}
+
+		public Type ScopeType {
+			get { return scope_type.Type; }
+		}
+
+		public void EmitScopeInstance (EmitContext ec)
 		{
-			if (computed_method_scope)
-				return;
-			
-			method_scope = null;
-			int top = scopes_used.Count;
-			computed_method_scope = true;
+			if (scope_initializer == null) {
+				//
+				// This is needed if someone overwrites the Emit method
+				// of Statement and manually calls Block.Emit without
+				// this snippet first:
+				// 
+				//   ec.EmitScopeInitFromBlock (The_Block);
+				//   The_Block.Emit (ec);
+				// 
+				throw new InternalErrorException ();
+			}
 
-			if (top == 0)
-				return;
-			
-			method_scope = (ScopeInfo) scopes_used [0];
-			if (top == 1)
-				return;
-			
-			for (int i = 1; i < top; i++)
-				method_scope = Deepest (method_scope, (ScopeInfo) scopes_used [i]);
+			Report.Debug (64, "EMIT SCOPE INSTANCE", this, GetType (), scope_initializer);
+			if (this is IteratorHost)
+				ec.ig.Emit (OpCodes.Ldarg_0);
+			else
+				scope_initializer.Emit (ec);
 		}
 
-		public ScopeInfo Scope {
-			get {
-				if (computed_method_scope)
-					return method_scope;
+		public ExpressionStatement GetScopeInitializer (EmitContext ec)
+		{
+			Report.Debug (64, "GET SCOPE INITIALIZER", this, GetType (), scope_initializer);
+			if (scope_initializer == null) {
+				scope_initializer = CreateScopeInitializer ();
+				if (scope_initializer.Resolve (ec) == null)
+					throw new InternalErrorException ();
+			}
 
-				//
-				// This means that ComputeMethodHost is not being called, most
-				// likely by someone who overwrote the CreateMethodHost method
-				//
-				throw new Exception ("Internal error, AnonymousContainer.Scope is being used before its container is computed");
+			return scope_initializer;
+		}
+
+		protected abstract ScopeInitializerBase CreateScopeInitializer ();
+
+		protected override bool DoPopulateType ()
+		{
+			Report.Debug (64, "SCOPE INFO RESOLVE TYPE", this, GetType (), IsGeneric,
+				      Parent.IsGeneric, GenericMethod);
+
+			if (IsGeneric) {
+				TypeArguments targs = new TypeArguments (Location);
+				if (Parent.IsGeneric)
+					foreach (TypeParameter t in Parent.TypeParameters)
+						targs.Add (new TypeParameterExpr (t, Location));
+				if (GenericMethod != null)
+					foreach (TypeParameter t in GenericMethod.TypeParameters)
+						targs.Add (new TypeParameterExpr (t, Location));
+
+				scope_type = new ConstructedType (TypeBuilder, targs, Location);
+				scope_type = scope_type.ResolveAsTypeTerminal (this, false);
+				if ((scope_type == null) || (scope_type.Type == null))
+					return false;
+			} else {
+				scope_type = new TypeExpression (TypeBuilder, Location);
 			}
+
+			if (Host != this)
+				scope_instance = Host.CaptureVariable (MakeName ("scope"), ScopeType);
+
+			return base.DoPopulateType ();
 		}
-		
-		
-		protected abstract bool CreateMethodHost (EmitContext ec);
 
-		public abstract void CreateScopeType (EmitContext ec, ScopeInfo scope);
+		protected abstract class ScopeInitializerBase : ExpressionStatement
+		{
+			ScopeInfoBase scope;
+			protected Variable scope_instance;
+			ConstructorInfo scope_ctor;
 
-		public abstract Iterator Iterator {
-			get;
+			bool initialized;
+
+			protected ScopeInitializerBase (ScopeInfoBase scope)
+			{
+				this.scope = scope;
+				this.loc = scope.Location;
+				eclass = ExprClass.Value;
+			}
+
+			public ScopeInfoBase Scope {
+				get { return scope; }
+			}
+
+			public override Expression DoResolve (EmitContext ec)
+			{
+				if (scope_ctor != null)
+					return this;
+
+				Report.Debug (64, "RESOLVE SCOPE INITIALIZER BASE", this, Scope);
+
+				type = Scope.ScopeType;
+
+				if (!DoResolveInternal (ec))
+					throw new InternalErrorException ();
+
+				return this;
+			}
+
+			protected virtual bool DoResolveInternal (EmitContext ec)
+			{
+				MethodGroupExpr mg = (MethodGroupExpr) Expression.MemberLookupFinal (
+					ec, ec.ContainerType, type, ".ctor", MemberTypes.Constructor,
+					AllBindingFlags | BindingFlags.DeclaredOnly, loc);
+				if (mg == null)
+					throw new InternalErrorException ();
+
+				scope_ctor = (ConstructorInfo) mg.Methods [0];
+
+				if (Scope.ScopeInstance != null)
+					scope_instance = new CapturedField (Scope.ScopeInstance);
+				else {
+					LocalBuilder local = ec.ig.DeclareLocal (type);
+					scope_instance = new CapturedTemporary (Scope, local);
+				}
+				return true;
+			}
+
+			static int next_id;
+			int id = ++next_id;
+
+			protected void DoEmit (EmitContext ec)
+			{
+				if (initialized)
+					return;
+				initialized = true;
+
+				Report.Debug (64, "EMIT SCOPE INIT", this, id,
+					      Scope, scope_instance, ec);
+
+				ec.ig.Emit (OpCodes.Nop);
+				ec.ig.Emit (OpCodes.Ldc_I4, id);
+				ec.ig.Emit (OpCodes.Pop);
+				ec.ig.Emit (OpCodes.Nop);
+
+				DoEmitInternal (ec);
+			}
+
+			protected virtual void EmitScopeConstructor (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Newobj, scope_ctor);
+			}
+
+			protected virtual void DoEmitInternal (EmitContext ec)
+			{
+				scope_instance.EmitInstance (ec);
+				EmitScopeConstructor (ec);
+				scope_instance.EmitAssign (ec);
+			}
+
+			public override void Emit (EmitContext ec)
+			{
+				DoEmit (ec);
+				scope_instance.EmitInstance (ec);
+				scope_instance.Emit (ec);
+			}
+
+			public override void EmitStatement (EmitContext ec)
+			{
+				DoEmit (ec);
+			}
 		}
 
-		public abstract bool IsIterator {
-			get;
+		protected class CapturedTemporary : Variable {
+			public readonly ScopeInfoBase Scope;
+			public readonly LocalBuilder Local;
+
+			public CapturedTemporary (ScopeInfoBase scope, LocalBuilder local)
+			{
+				this.Scope = scope;
+				this.Local = local;
+			}
+
+			public override Type Type {
+				get { return Local.LocalType; }
+			}
+
+			public override bool HasInstance {
+				get { return false; }
+			}
+
+			public override bool NeedsTemporary {
+				get { return false; }
+			}
+
+			public override void EmitInstance (EmitContext ec)
+			{ }
+
+			public override void Emit (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldloc, Local);
+			}
+
+			public override void EmitAssign (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Stloc, Local);
+			}
+
+			public override void EmitAddressOf (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldloca, Local);
+			}
 		}
+
+		protected class CapturedField : Variable {
+			public readonly Field Field;
+
+			public CapturedField (Field field)
+			{
+				this.Field = field;
+			}
+
+			public override Type Type {
+				get { return Field.MemberType; }
+			}
+
+			public override bool HasInstance {
+				get { return true; }
+			}
+
+			public override bool NeedsTemporary {
+				get { return true; }
+			}
+
+			public override void EmitInstance (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldarg_0);
+			}
+
+			public override void Emit (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldfld, Field.FieldBuilder);
+			}
+
+			public override void EmitAssign (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Stfld, Field.FieldBuilder);
+			}
+
+			public override void EmitAddressOf (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldflda, Field.FieldBuilder);
+			}
+		}
 	}
 
-	public class AnonymousMethod : AnonymousContainer
+	public class AnonymousMethodHost : ScopeInfo
 	{
-		TypeContainer host;
+		public AnonymousMethodHost (CaptureContext cc, ToplevelBlock toplevel,
+					    TypeContainer parent, GenericMethod generic)
+			: base (cc, toplevel, parent, generic)
+		{ }
 
-		//
-		// The value return by the Compatible call, this ensure that
-		// the code works even if invoked more than once (Resolve called
-		// more than once, due to the way Convert.ImplicitConversion works
-		//
-		Expression anonymous_delegate;
+		public bool HostsParameters = false;
 
-		public AnonymousMethod (TypeContainer host, Parameters parameters, ToplevelBlock container,
-					ToplevelBlock block, Location l)
-			: base (parameters, container, block, l)
+		TypeExpr parent_type;
+		CapturedVariable parent_link;
+		CapturedVariable this_field;
+
+		public override AnonymousMethodHost Host {
+			get { return this; }
+		}
+
+		public AnonymousMethodHost ParentHost {
+			get { return Parent as AnonymousMethodHost; }
+		}
+
+		public Type ParentType {
+			get { return parent_type.Type; }
+		}
+
+		public Field ParentLink {
+			get { return parent_link; }
+		}
+
+		public Field THIS {
+			get { return this_field; }
+		}
+
+		public Field CaptureThis ()
 		{
-			this.host = host;
+			CheckMembersDefined ();
+			if (Parent is CompilerGeneratedClass)
+				throw new InternalErrorException ("CaptureThis called in inner class!");
+
+			if (this_field == null)
+				this_field = new CapturedVariable (this, "<>THIS", parent_type);
+			return this_field;
 		}
 
-		public override Iterator Iterator {
-			get { return null; }
+		protected override ScopeInitializerBase CreateScopeInitializer ()
+		{
+			return new AnonymousMethodHostInitializer (this);
 		}
 
-		public override bool IsIterator {
-			get { return false; }
+		protected override bool DefineNestedTypes ()
+		{
+			Report.Debug (64, "ANONYMOUS METHOD HOST NESTED",
+				      this, Name, Parent, Parent.Name, Parent.IsGeneric);
+
+			if (Parent.IsGeneric) {
+				parent_type = new ConstructedType (
+					Parent.TypeBuilder, Parent.TypeParameters, Location);
+				parent_type = parent_type.ResolveAsTypeTerminal (this, false);
+				if ((parent_type == null) || (parent_type.Type == null))
+					return false;
+			} else {
+				parent_type = new TypeExpression (Parent.TypeBuilder, Location);
+			}
+
+			CompilerGeneratedClass parent = Parent as CompilerGeneratedClass;
+			if (parent != null)
+				parent_link = new CapturedVariable (this, "<>parent", parent_type);
+
+			return base.DefineNestedTypes ();
 		}
 
-		public override void Emit (EmitContext ec)
+		protected override bool DoDefineMembers ()
 		{
-			// nothing, as we only exist to not do anything.
+			Report.Debug (64, "ANONYMOUS METHOD HOST DEFINE MEMBERS",
+				      this, Name, Parent, CompilerGenerated);
+
+			ArrayList args = new ArrayList ();
+			if (this is IteratorHost)
+				args.Add (new Parameter (
+					TypeManager.int32_type, "$PC", Parameter.Modifier.NONE,
+					null, Location));
+
+			Field pfield = Parent is CompilerGeneratedClass ? parent_link : this_field;
+			if (pfield != null)
+				args.Add (new Parameter (
+					pfield.MemberType, "parent", Parameter.Modifier.NONE,
+					null, Location));
+
+			if (HostsParameters) {
+				Hashtable hash = CaptureContext.captured_parameters;
+				foreach (CapturedParameter cp in hash.Values) {
+					args.Add (new Parameter (
+							  cp.Field.MemberType, cp.Field.Name,
+							  Parameter.Modifier.NONE, null, Location));
+				}
+			}
+
+			Parameter[] ctor_params = new Parameter [args.Count];
+			args.CopyTo (ctor_params, 0);
+			Constructor ctor = new Constructor (
+				this, MemberName.Name, Modifiers.PUBLIC,
+				new Parameters (ctor_params),
+				new GeneratedBaseInitializer (Location),
+				Location);
+			AddConstructor (ctor);
+
+			ctor.Block = new ToplevelBlock (null, Location);
+			ctor.Block.AddStatement (new TheCtor (this));
+
+			return base.DoDefineMembers ();
 		}
 
-		//
-		// Creates the host for the anonymous method
-		//
-		protected override bool CreateMethodHost (EmitContext ec)
+		protected virtual void EmitScopeConstructor (EmitContext ec)
 		{
-			ComputeMethodHost ();
+			int pos = (this is IteratorHost) ? 2 : 1;
+			Field pfield = Parent is CompilerGeneratedClass ? parent_link : this_field;
+			if (pfield != null) {
+				ec.ig.Emit (OpCodes.Ldarg_0);
+				ec.ig.Emit (OpCodes.Ldarg_1);
+				ec.ig.Emit (OpCodes.Stfld, pfield.FieldBuilder);
+				pos++;
+			}
 
-			//
-			// Crude hack follows: we replace the TypeBuilder during the
-			// definition to get the method hosted in the right class
-			//
-			TypeBuilder current_type = ec.TypeContainer.TypeBuilder;
-			TypeBuilder type_host = (Scope == null ) ? current_type : Scope.ScopeTypeBuilder;
+			if (HostsParameters) {
+				Hashtable hash = CaptureContext.captured_parameters;
+				foreach (CapturedParameter cp in hash.Values) {
+					ec.ig.Emit (OpCodes.Ldarg_0);
+					ParameterReference.EmitLdArg (ec.ig, pos++);
+					ec.ig.Emit (OpCodes.Stfld, cp.Field.FieldBuilder);
+				}
+			}
+		}
 
-			if (current_type == null)
-				throw new Exception ("The current_type is null");
-			
-			if (type_host == null)
-				throw new Exception (String.Format ("Type host is null, method_host is {0}", Scope == null ? "null" : "Not null"));
+		protected class TheCtor : Statement
+		{
+			AnonymousMethodHost host;
 
-			if (current_type != type_host)
-				method_modifiers = Modifiers.INTERNAL;
+			public TheCtor (AnonymousMethodHost host)
+			{
+				this.host = host;
+			}
 
-			if (current_type == type_host && ec.IsStatic){
-				method_modifiers |= Modifiers.STATIC;
-				current_type = null;
-			} 
+			public override bool Resolve (EmitContext ec)
+			{
+				return true;
+			}
 
-			string name = "<#AnonymousMethod>" + anonymous_method_count++;
-			MemberName member_name;
+			protected override void DoEmit (EmitContext ec)
+			{
+				host.EmitScopeConstructor (ec);
+			}
+		}
 
-			GenericMethod generic_method = null;
-			if (TypeParameters != null) {
-				TypeArguments args = new TypeArguments (loc);
-				foreach (string t in TypeParameters)
-					args.Add (new SimpleName (t, loc));
+		protected class AnonymousMethodHostInitializer : ScopeInitializer
+		{
+			AnonymousMethodHost host;
+			ExpressionStatement parent_init;
 
-				member_name = new MemberName (name, args, loc);
+			public AnonymousMethodHostInitializer (AnonymousMethodHost host)
+				: base (host)
+			{
+				this.host = host;
+			}
 
-				generic_method = new GenericMethod (
-					ec.DeclContainer.NamespaceEntry,
-					(TypeContainer) ec.TypeContainer, member_name,
-					new TypeExpression (invoke_mb.ReturnType, loc),
-					Parameters);
+			public AnonymousMethodHost Host {
+				get { return host; }
+			}
 
-				generic_method.SetParameterInfo (null);
-			} else
-				member_name = new MemberName (name, loc);
+			protected override bool DoResolveInternal (EmitContext ec)
+			{
+				Report.Debug (64, "RESOLVE ANONYMOUS METHOD HOST INITIALIZER",
+					      this, Host, Host.ScopeType, Host.ParentType, loc);
 
-			method = new Method (
-				(TypeContainer) ec.TypeContainer, generic_method,
-				new TypeExpression (invoke_mb.ReturnType, loc),
-				method_modifiers, false, member_name, Parameters, null);
-			method.Block = Block;
+				//
+				// Copy the parameter values, if any
+				//
+				if (Host.HostsParameters){
+					Hashtable hash = Host.CaptureContext.captured_parameters;
+					foreach (CapturedParameter cp in hash.Values) {
+						FieldExpr fe = (FieldExpr) Expression.MemberLookup (
+							ec.ContainerType, type, cp.Field.Name, loc);
+						if (fe == null)
+							throw new InternalErrorException ();
 
-			//
-			// Swap the TypeBuilder while we define the method, then restore
-			//
-			if (current_type != null)
-				ec.TypeContainer.TypeBuilder = type_host;
-			bool res = method.Define ();
-			if (current_type != null)
-				ec.TypeContainer.TypeBuilder = current_type;
+						fe.InstanceExpression = this;
+						cp.FieldInstance = fe;
+					}
+				}
 
-			return res;
+				return base.DoResolveInternal (ec);
+			}
+
+			protected override void EmitScopeConstructor (EmitContext ec)
+			{
+				if ((host.THIS != null) || (host.ParentLink != null))
+					ec.ig.Emit (OpCodes.Ldarg_0);
+
+				if (Host.HostsParameters) {
+					Hashtable hash = Host.CaptureContext.captured_parameters;
+					foreach (CapturedParameter cp in hash.Values) {
+						EmitParameterReference (ec, cp);
+					}
+				}
+
+				base.EmitScopeConstructor (ec);
+			}
 		}
 
+	}
+
+	public interface IAnonymousContainer
+	{
+		ToplevelBlock Container {
+			get;
+		}
+
+		GenericMethod GenericMethod {
+			get;
+		}
+
+		AnonymousMethodHost RootScope {
+			get;
+		}
+
+		bool IsIterator {
+			get;
+		}
+	}
+
+	public class AnonymousMethodExpression : Expression, IAnonymousContainer
+	{
+		public readonly AnonymousMethodExpression Parent;
+		public readonly TypeContainer Host;
+		public readonly Parameters Parameters;
+
+		public ToplevelBlock Block;
+		protected AnonymousMethod anonymous;
+
+		protected readonly ToplevelBlock container;
+		protected readonly GenericMethod generic;
+
+		public ToplevelBlock Container {
+			get { return container; }
+		}
+
+		public GenericMethod GenericMethod {
+			get { return generic; }
+		}
+
+		public AnonymousMethod AnonymousMethod {
+			get { return anonymous; }
+		}
+
+		public AnonymousMethodHost RootScope {
+			get { return container.AnonymousMethodHost; }
+		}
+
+		public AnonymousMethodExpression (AnonymousMethodExpression parent,
+						  GenericMethod generic, TypeContainer host,
+						  Parameters parameters, ToplevelBlock container,
+						  Location loc)
+		{
+			this.Parent = parent;
+			this.generic = parent != null ? null : generic;
+			this.Host = host;
+			this.Parameters = parameters;
+			this.container = container;
+			this.loc = loc;
+
+			Report.Debug (64, "NEW ANONYMOUS METHOD EXPRESSION", this, parent, host,
+				      container, loc);
+
+			container.SetHaveAnonymousMethods (loc, this);
+			container.CreateAnonymousMethodHost (Host);
+		}
+
+		public override string ExprClassName {
+			get {
+				return "anonymous method";
+			}
+		}
+
 		void Error_ParameterMismatch (Type t)
 		{
 			Report.Error (1661, loc, "Anonymous method could not be converted to delegate `" +
-				      "{0}' since there is a parameter mismatch", TypeManager.CSharpName (t));
+				      "{0}' since there is a parameter mismatch",
+				      TypeManager.CSharpName (t));
 		}
 
 		public bool ImplicitStandardConversionExists (Type delegate_type)
@@ -318,8 +742,9 @@
 			if (Parameters == null)
 				return true;
 
-			MethodGroupExpr invoke_mg = Delegate.GetInvokeMethod (host.TypeBuilder, delegate_type, loc);
-			invoke_mb = (MethodInfo) invoke_mg.Methods [0];
+			MethodGroupExpr invoke_mg = Delegate.GetInvokeMethod (
+				Host.TypeBuilder, delegate_type, loc);
+			MethodInfo invoke_mb = (MethodInfo) invoke_mg.Methods [0];
 			ParameterData invoke_pd = TypeManager.GetParameterData (invoke_mb);
 
 			if (Parameters.Count != invoke_pd.Count)
@@ -338,31 +763,20 @@
 		//
 		public Expression Compatible (EmitContext ec, Type delegate_type)
 		{
-			if (anonymous_delegate != null)
-				return anonymous_delegate;
-			
+			if (anonymous != null)
+				return anonymous.AnonymousDelegate;
+
 			//
 			// At this point its the first time we know the return type that is 
 			// needed for the anonymous method.  We create the method here.
 			//
 
-			MethodGroupExpr invoke_mg = Delegate.GetInvokeMethod (ec.ContainerType, delegate_type, loc);
-			invoke_mb = (MethodInfo) invoke_mg.Methods [0];
+			MethodGroupExpr invoke_mg = Delegate.GetInvokeMethod (
+				ec.ContainerType, delegate_type, loc);
+			MethodInfo invoke_mb = (MethodInfo) invoke_mg.Methods [0];
 			ParameterData invoke_pd = TypeManager.GetParameterData (invoke_mb);
 
-			if (delegate_type.IsGenericType) {
-				Type def = delegate_type.GetGenericTypeDefinition ();
-
-				if (def != delegate_type) {
-					Type[] tparam = TypeManager.GetTypeArguments (def);
-
-					TypeArguments = TypeManager.GetTypeArguments (delegate_type);
-					TypeParameters = new string [tparam.Length];
-					for (int i = 0; i < tparam.Length; i++)
-						TypeParameters [i] = tparam [i].Name;
-				}
-			}
-
+			Parameters parameters;
 			if (Parameters == null) {
 				//
 				// We provide a set of inaccessible parameters
@@ -375,7 +789,9 @@
 						"+" + i, invoke_pd.ParameterModifier (i), null, loc);
 				}
 								
-				Parameters = new Parameters (fixedpars);
+				parameters = new Parameters (fixedpars);
+				if (!parameters.Resolve (ec))
+					return null;
 			} else {
 				if (Parameters.Count != invoke_pd.Count) {
 					Report.SymbolRelatedToPreviousError (delegate_type);
@@ -407,8 +823,10 @@
 						return null;
 					}
 				}
+
+				parameters = Parameters;
 			}
-			
+
 			//
 			// Second: the return type of the delegate must be compatible with 
 			// the anonymous type.   Instead of doing a pass to examine the block
